Index: /branches/nemo_v3_3_beta/DOC/NEMO_book.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/NEMO_book.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/NEMO_book.tex	(revision 2414)
@@ -19,21 +19,24 @@
 \usepackage{verbatim}  	%%  alltt for namelist
 
-%hyperref  ===>>>  don't work.....
-%\usepackage[a4paper=true,ps2pdf=true,pagebackref=true,breaklinks=true]{hyperref}
-%gn
-\usepackage[%
-  pdftitle={NEMO ocean engine},%
-  pdfauthor={Gurvan Madec},% pdfsubject={The preprint document class
-                           % elsart},% pdfkeywords={diapycnal diffusion,numerical mixing,z-level models},%
-  pdfstartview=FitH,%
-  bookmarks=true,%
-  bookmarksopen=true,%
-  breaklinks=true,%
-  colorlinks=true,%
-  linkcolor=blue,anchorcolor=blue,%
-  citecolor=blue,filecolor=blue,%
-  menucolor=blue,pagecolor=blue,%
+%hyperref 
+\usepackage[					%
+  pdftitle={NEMO ocean engine},	%
+  pdfauthor={Gurvan Madec},		% pdfsubject={The preprint document class
+                           				% elsart},% pdfkeywords={diapycnal diffusion,numerical mixing,z-level models},%
+  pdfstartview=FitH,				%
+  bookmarks=true,				%
+  bookmarksopen=true,			%
+  breaklinks=true,				%
+  colorlinks=true,				%
+  linkcolor=blue,anchorcolor=blue,	%
+  citecolor=blue,filecolor=blue,		%
+  menucolor=blue,pagecolor=blue,	%
   urlcolor=blue]{hyperref}
-%gn end
+%  usage of exteranl hyperlink :  \href{mailto:my_address@wikibooks.org}{my\_address@wikibooks.org}
+%                                                 \url{http://www.wikibooks.org}
+%                                     or         \href{http://www.wikibooks.org}{wikibooks home}
+
+
+
 
 %\usepackage{amssymb}
@@ -162,6 +165,7 @@
 	\begin{alltt}  {{\tiny \verbatiminput{./TexFiles/Namelist/#1}}}  \end{alltt} 
                                \vspace{-10pt}	}
+%--------------------------------------------code display---------------------------------------------------------
+%\newcommand{\codedisplay} [1] { \begin{alltt} {\tiny  {\begin{verbatim} {#1}} \end{verbatim} }  \end{alltt}   }
 %--------------------------------------------------------------------------------------------------------------
-
 %Red (NR) or Yellow(WARN)
 %\newcommand{\NR} {\colorbox{red}{#1}}
@@ -237,5 +241,5 @@
 % ================================================================
 
-%\includeonly{./TexFiles/Chapters/Chap_MISC}
+%\includeonly{./TexFiles/Chapters/Chap_MISC, ./TexFiles/Chapters/Chap_CFG}
 %\includeonly{./TexFiles/Chapters/Chap_ZDF}
 %\includeonly{./TexFiles/Chapters/Chap_STP,./TexFiles/Chapters/Chap_SBC,./TexFiles/Chapters/Chap_TRA}
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Abstracts_Foreword.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Abstracts_Foreword.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Abstracts_Foreword.tex	(revision 2414)
@@ -64,5 +64,5 @@
 
  \vspace{0.5cm}
-Additional information can be found on http://www.nemo-ocean.eu/
+Additional information can be found on \href{http://www.nemo-ocean.eu/}{nemo-ocean.eu} website.
  \vspace{0.5cm}
 
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Annex_D.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Annex_D.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Annex_D.tex	(revision 2414)
@@ -196,2 +196,4 @@
 \section{The program structure}
 \label{Apdx_D_structure}
+
+To be done....
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_CFG.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_CFG.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_CFG.tex	(revision 2414)
@@ -33,5 +33,5 @@
 % 1D model functionality
 % ================================================================
-\section{Water column model: 1D model (\key{c1d})}
+\section{Water column model: 1D model (C1D) (\key{c1d})}
 \label{CFG_c1d}
 
@@ -61,5 +61,5 @@
 This requires a specific treatment of the Coriolis term (see \rou{dyncor\_c1d}) and of the 
 dynamic time stepping (\rou{dynnxt\_c1d}).
-All the relevant modules can be found in the NEMOGCM/NEMO/C1D\_SRC directory of 
+All the relevant modules can be found in the NEMOGCM/NEMO/OPA\_SRC/C1D directory of 
 the \NEMO distribution.
 
@@ -145,5 +145,5 @@
 
 %--------------------------------------------------TABLE--------------------------------------------------
-\begin{table}[!b]     \begin{center}
+\begin{table}[!t]     \begin{center}
 \begin{tabular}{p{4cm} c c c c}
 CPP key          	             & \jp{jp\_cfg} &  \jp{jpiglo} & \jp{jpiglo} &       \\  
@@ -192,5 +192,5 @@
 which was developed for the purpose of running global coupled ocean-ice simulations 
 without an interactive atmosphere. This \citet{Large_Yeager_Rep04} dataset is available 
-through the GFDL web site \footnote{http://nomads.gfdl.noaa.gov/nomads/forms/mom4/CORE.html}. 
+through the \href{http://nomads.gfdl.noaa.gov/nomads/forms/mom4/CORE.html}{GFDL web site}. 
 The "normal year" of \citet{Large_Yeager_Rep04} has been chosen of the \NEMO distribution 
 since release v3.3. 
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_LBC.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_LBC.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_LBC.tex	(revision 2414)
@@ -558,5 +558,6 @@
 to indices $ib:ie$, $jb:je$ of the global domain, the bathymetry and forcing of the 
 small domain can be created by using the following netcdf utility on the global files: 
-ncks -F $-d\;x,ib,ie$ $-d\;y,jb,je$ (part of the nco series of utilities, see http://nco.sourceforge.net). 
+ncks -F $-d\;x,ib,ie$ $-d\;y,jb,je$ (part of the nco series of utilities, 
+see their \href{http://nco.sourceforge.net}{website}). 
 The open boundary files can be constructed using ncks 
 commands, following table~\ref{Tab_obc_ind}. 
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_MISC.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_MISC.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_MISC.tex	(revision 2414)
@@ -521,6 +521,6 @@
 and compression can lead to significant reductions in file sizes for a small
 runtime overhead. For a fuller discussion on chunking and other performance
-issues the reader is referred to the NetCDF4 documentation:
-http://www.unidata.ucar.edu/software/netcdf/docs/netcdf.html\#Chunking
+issues the reader is referred to the NetCDF4 documentation found 
+\href{http://www.unidata.ucar.edu/software/netcdf/docs/netcdf.html#Chunking}{here}.
 
 The new features are only available when the code has been linked with a
@@ -562,5 +562,5 @@
 domain size in any dimension. The algorithm used is:
 
-\begin{alltt}  {{\tiny 
+\begin{alltt}  {{\scriptsize 
 \begin{verbatim}
      ichunksz(1) = MIN( idomain_size,MAX( (idomain_size-1)/nn_nchunks_i + 1 ,16 ) )
@@ -573,5 +573,5 @@
 \noindent As an example, setting:
 \vspace{-20pt}
-\begin{alltt}  {{\tiny
+\begin{alltt}  {{\scriptsize
 \begin{verbatim}
      nn_nchunks_i=4, nn_nchunks_j=4 and nn_nchunks_k=31
@@ -671,5 +671,5 @@
 The units in the output file can be changed using the \np{nn\_ucf} namelist parameter. 
 For example, in case of salinity tendency the units are given by PSU/s/\np{nn\_ucf}.
-Setting \np{nn\_ucf}=86400 provides the tendencies in PSU/d.
+Setting \np{nn\_ucf}=86400 ($i.e.$ the number of second in a day) provides the tendencies in PSU/d.
 
 When \key{trdmld} is defined, two time averaging procedure are proposed.
@@ -684,10 +684,10 @@
 
 Note that the mixed layer tendency diagnostic can also be used on biogeochemical models 
-via Êthe \key{trdtrc} and \key{trdmld\_trc} CPP keys.
+via the \key{trdtrc} and \key{trdmld\_trc} CPP keys.
 
 % -------------------------------------------------------------------------------------------------------------
 %       On-line Floats trajectories
 % -------------------------------------------------------------------------------------------------------------
-\subsection{On-line Floats trajectories (FLO) (\key{floats}}
+\subsection{On-line Floats trajectories (FLO) (\key{floats})}
 \label{FLO}
 %--------------------------------------------namflo-------------------------------------------------------
@@ -703,6 +703,6 @@
 numeric of the code, so that the trajectories never intercept the bathymetry. 
 
-See also the web site describing the off-line use of this marvellous diagnostic tool 
-(http://stockage.univ-brest.fr/~grima/Ariane/).
+See also \href{http://stockage.univ-brest.fr/~grima/Ariane/}{here} the web site describing 
+the off-line use of this marvellous diagnostic tool.
 
 % -------------------------------------------------------------------------------------------------------------
@@ -912,3 +912,457 @@
 
 
-% ================================================================
+
+\gmcomment{                    % start of gmcomment
+
+
+% ================================================================
+% Diagnostics
+% ================================================================
+\section{Standard model Output (IOM)}
+\label{MISC_iom}
+
+% -------------------------------------------------------------------------------------------------------------
+%       Standard Model Output 
+% -------------------------------------------------------------------------------------------------------------
+%\subsection{Model Output (default or \key{iomput} }
+%\label{MISC_iom}
+
+
+
+\subsection{Basic knowledge}
+
+
+\subsubsection{ XML basic rules}
+
+XML tags begin with the less-than character ("$<$") and end with the greater-than character (''$>$''). 
+You use tags to mark the start and end of elements, which are the logical units of information 
+in an XML document. In addition to marking the beginning of an element, XML start tags also 
+provide a place to specify attributes. An attribute specifies a single property for an element, 
+using a name/value pair, for example: $<$a b="x" c="y" b="z"$>$ ... $<$/a$>$.
+See \href{http://www.xmlnews.org/docs/xml-basics.html}{here} for more details.
+
+\subsubsection{Structure of the xml file used in NEMO}
+
+The xml file is split into 3 parts:
+
+\textbf{field definition}: define all variables that can be output (all lines between   
+\texttt{$<$field\_definition$>$} and \texttt{$<$/field\_definition$>$})
+
+\textbf{file definition}: define the netcdf files to be created and the variables they will contain 
+(all lines between \texttt{ $<$file\_definition$>$} and \texttt{$<$/file\_definition$>$})
+
+\textbf{axis and grid definitions}: define the horizontal and vertical grids (all lines between 
+\texttt{$<$axis\_definition$>$} and \texttt{$<$/axis\_definition$>$} and all lines between 
+\texttt{$<$grid\_definition$>$} and \texttt{$<$/grid\_definition$>$})
+
+\subsubsection{Inheritance and group }
+
+ Xml extensively uses the concept of inheritance. \\
+\\
+example 1: \\
+\vspace{-30pt}
+\begin{alltt}  {{\scriptsize    
+\begin{verbatim}
+   <field_definition operation="ave(X)" >
+      <field id="sst"                    />   <!-- averaged      sst --> 
+      <field id="sss" operation="inst(X)"/>   <!-- instantaneous sss --> 
+   </field_definition> 
+\end{verbatim}
+}}\end{alltt} 
+
+The field ''sst'' which is part (or a child) of the field\_definition will inherit the value ''ave(X)'' 
+of the attribute ''operation'' from its parent ''field definition''. Note that a child can overwrite 
+the attribute definition inherited from its parents. In the example above, the field ''sss'' will 
+therefore output instantaneous values instead of average values.
+
+example 2: Use (or overwrite) attributes value of a field when listing the variables included in a file
+\vspace{-20pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+   <field_definition>
+      <field id="sst" description="sea surface temperature" />   
+      <field id="sss" description="sea surface salinity"    />  
+   </field_definition>      
+
+   <file_definition>
+      <file id="file_1" />   
+            <field ref="sst"                              />  <!-- default def -->
+            <field ref="sss" description="my description" />  <!-- overwrite   -->
+      </file>   
+   </file_definition> 
+\end{verbatim}
+}}\end{alltt} 
+
+With the help of the inheritance, the concept of group allow to define a set of attributes 
+for several fields or files. 
+
+example 3, group of fields: define a group ''T\_grid\_variables'' identified with the name 
+''grid\_T''. By default variables of this group have no vertical axis but, following inheritance 
+rules, ''axis\_ref'' can be redefined for the field ''toce'' that is a 3D variable.
+\vspace{-30pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+   <field_definition>
+      <group id="grid_T" axis_ref="none" grid_ref="T_grid_variables">
+            <field id="sst"/>  
+            <field id="sss"/>  
+            <field id="toce" axis_ref="deptht"/>  <!-- overwrite axis def -->
+      </group>
+   </field_definition> 
+\end{verbatim}
+}}\end{alltt} 
+
+example 4, group of files: define a group of file with the attribute output\_freq equal to 432000 (5 days)
+\vspace{-30pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+   <file_definition>
+      <group id="5d" output_freq="432000">    <!-- 5d files -->
+         <file id="5d_grid_T" name="auto">   <!-- T grid file -->
+         ...
+         </file>
+         <file id="5d_grid_U" name="auto">   <!-- U grid file -->
+         ...
+         </file>
+      </group>
+   </file_definition> 
+\end{verbatim}
+}}\end{alltt} 
+
+\subsubsection{Control of the xml attributes from NEMO}
+
+The values of some attributes are automatically defined by NEMO (and any definition 
+given in the xml file is overwritten). By convention, these attributes are defined to ''auto'' 
+(for string) or ''0000'' (for integer) in the xml file (but this is not necessary). 
+
+Here is the list of these attributes: \\
+
+%table to be created here....
+
+tag ids affected by automatic definition of some of their attributes
+
+name attribute
+attribute value
+field\_definition
+freq\_op
+\np{rn\_rdt} (namelist)
+SBC
+freq\_op
+\np{rn\_rdt} $\times$ \np{nn\_fsbc} (namelist)
+1h, 2h, 3h, 4h, 6h, 12h
+1d, 3d, 5d
+1m, 2m, 3m, 4m, 6m
+1y, 2y, 5y, 10y
+\_grid\_T, \_grid\_U, \_grid\_V, \_grid\_W, \_icemod, \_ptrc\_T, \_diad\_T, \_scalar
+name
+filename defined by a call to rou{dia\_nam} following NEMO nomenclature
+EqT, EqU, EqW
+jbegin, ni, name\_suffix
+according to the grid
+TAO, RAMA and PIRATA moorings
+ibegin, jbegin, name\_suffix
+according to the grid
+
+
+\subsection{ Detailed functionalities }
+
+\subsubsection{Tag list}
+
+
+Table might be easier to read:        % table to create
+
+Tag
+Description
+Accepted attribute
+Accepted attribute value(s)
+Parent tag
+context
+define the model using the xml file
+id
+"nemo" or "n\_nemo" for the nth AGRIF zoom.
+simulation
+
+What do you think, Seb?
+
+
+\begin{description}
+
+\item[context]: define the model using the xml file. Id is the only attribute accepted. 
+Its value must be ''nemo'' or ''n\_nemo'' for the nth AGRIF zoom. Child of simulation tag.
+
+\item[field]: define the field to be output. Accepted attributes are axis\_ref, description, enable, 
+freq\_op, grid\_ref, id (if child of field\_definition), level, operation, name, ref (if child of file), 
+unit, zoom\_ref. Child of field\_definition, file or group of fields tag.
+
+\item[field\_definition]: definition of the part of the xml file corresponding to the field definition. 
+Accept the same attributes as field tag. Child of context tag.
+
+\item[group]: define a group of file or field. Accept the same attributes as file or field.
+
+\item[file]: define the output fileÕs characteristics. Accepted attributes are description, enable, 
+output\_freq, output\_level, id, name, name\_suffix. Child of file\_definition or group of files tag.
+
+\item[file\_definition]: definition of the part of the xml file corresponding to the file definition. 
+Accept the same attributes as file tag. Child of context tag.
+
+\item[axis]: definition of the vertical axis. Accepted attributes are description, id, positive, size, unit. 
+Child of axis\_definition tag.
+
+\item[axis\_definition]: definition of the part of the xml file corresponding to the vertical axis definition. 
+Accept the same attributes as axis tag. Child of context tag
+
+\item[grid]: definition of the horizontal grid. Accepted attributes are description and id. 
+Child of axis\_definition tag.
+
+\item[grid\_definition]: definition of the part of the xml file corresponding to the horizontal grid definition. 
+Accept the same attributes as grid tag. Child of context tag
+
+\item[zoom]: definition of a subdomain of an horizontal grid. Accepted attributes are description, id, 
+i/jbegin, ni/j. Child of grid tag.
+
+\end{description}
+
+
+\subsubsection{Attributes list}
+
+Applied to a tag or a group of tags.
+
+% table to be added ?
+Another table, perhaps?
+
+%%%%
+
+Attribute
+Applied to?
+Definition
+Comment
+axis\_ref
+field
+String defining the vertical axis of the variable. It refers to the id of the vertical axis defined in the axis tag.
+Use ''non'' if the variable has no vertical axis
+
+%%%%%%
+
+\begin{description}
+
+\item[axis\_ref]: field attribute. String defining the vertical axis of the variable. 
+It refers to the id of the vertical axis defined in the axis tag. 
+Use ''none'' if the variable has no vertical axis
+
+\item[description]: this attribute can be applied to all tags but it is used only with the field tag. 
+In this case, the value of description will be used to define, in the output netcdf file, 
+the attributes long\_name and standard\_name of the variable.
+
+\item[enabled]: field and file attribute. Logical to switch on/off the output of a field or a file. 
+
+\item[freq\_op]: field attribute (automatically defined, see part 1.4 (''control of the xml attributes'')). 
+An integer defining the frequency in seconds at which NEMO is calling iom\_put for this variable. 
+It corresponds to the model time step (rn\_rdt in the namelist) except for the variables computed 
+at the frequency of the surface boundary condition (rn\_rdt ? nn\_fsbc in the namelist).   
+
+\item[grid\_ref]: field attribute. String defining the horizontal grid of the variable. 
+It refers to the id of the grid tag.
+
+\item[ibegin]: zoom attribute. Integer defining the zoom starting point along x direction. 
+Automatically defined for TAO/RAMA/PIRATA moorings (see part 1.4).  
+
+\item[id]: exists for all tag. This is a string defining the name to a specific tag that will be used 
+later to refer to this tag. Tags of the same category must have different ids.
+
+\item[jbegin]: zoom attribute. Integer defining the zoom starting point along y direction. 
+Automatically defined for TAO/RAMA/PIRATA moorings and equatorial section (see part 1.4). 
+
+\item[level]: field attribute. Integer from 0 to 10 defining the output priority of a field. 
+See output\_level attribute definition
+
+\item[operation]: field attribute. String defining the type of temporal operation to perform on a variable. 
+Possible choices are ''ave(X)'' for temporal mean, ''inst(X)'' for instantaneous, ''t\_min(X)'' for temporal min 
+and ''t\_max(X)'' for temporal max.
+
+\item[output\_freq]: file attribute. Integer defining the operation frequency in seconds. 
+For example 86400 for daily mean.
+
+\item[output\_level]: file attribute. Integer from 0 to 10 defining the output priority of variables in a file: 
+all variables listed in the file with a level smaller or equal to output\_level will be output. 
+Other variables wonÕt be output even if they are listed in the file.  
+
+\item[positive]: axis attribute (always .FALSE.). Logical defining the vertical axis convention used 
+in \NEMO (positive downward). Define the attribute positive of the variable in the netcdf output file.
+
+\item[prec]: field attribute. Integer defining the output precision. 
+Not implemented, we always output real4 arrays. 
+
+\item[name]: field or file attribute. String defining the name of a variable or a file. 
+If the name of a file is undefined, its id is used as a name. 2 files must have different names. 
+Files with specific ids will have their name automatically defined (see part 1.4). 
+Note that is name will be automatically completed by the cpu number (if needed) and ''.nc''
+
+\item[name\_suffix]: file attribute. String defining a suffix to be inserted after the name 
+and before the cpu number and the ''.nc'' termination. Files with specific ids have an 
+automatic definition of their suffix (see part 1.4).
+
+\item[ni]: zoom attribute. Integer defining the zoom extent along x direction. 
+Automatically defined for equatorial sections (see part 1.4).  
+
+\item[nj]: zoom attribute. Integer defining the zoom extent along x direction. 
+
+\item[ref]: field attribute. String referring to the id of the field we want to add in a file.
+
+\item[size]: axis attribute. use unknown...
+
+\item[unit]: field attribute. String defining the unit of a variable and the associated 
+attribute in the netcdf output file.
+
+\item[zoom\_ref]: field attribute. String defining the subdomain of data on which 
+the file should be written (to ouput data only in a limited area). 
+It refers to the id of a zoom defined in the zoom tag.
+\end{description}
+
+
+\subsection{IO\_SERVER}
+
+\subsubsection{Attached or detached mode?}
+
+Iom\_put is based on the io\_server developed by Yann Meurdesoif from IPSL 
+(see \href{http://forge.ipsl.jussieu.fr/ioserver/browser}{here} for the source code or 
+see its copy in NEMOGCM/EXTERNAL directory). 
+This server can be used in ''attached mode'' (as a library) or in ''detached mode'' 
+(as an external executable on n cpus). In attached mode, each cpu of NEMO will output 
+its own subdomain. In detached mode, the io\_server will gather data from NEMO 
+and output them split over n files with n the number of cpu dedicated to the io\_server.
+
+\subsubsection{Control the io\_server: the namelist file xmlio\_server.def}
+
+%
+%Again, a small table might be more readable?
+%Name
+%Type
+%Description
+%Comment
+%Using_server
+%Logical 
+%Switch to use the server in attached or detached mode
+%(.TRUE. corresponding to detached mode).
+
+The control of the use of the io\_server is done through the namelist file of the io\_server 
+called xmlio\_server.def.
+
+\textbf{using\_server}: logical, switch to use the server in attached or detached mode 
+(.TRUE. corresponding to detached mode).
+
+\textbf{using\_oasis}: logical, set to .TRUE. if NEMO is used in coupled mode.
+
+\textbf{client\_id} = ''oceanx'' : character, used only in coupled mode. 
+Specify the id used in OASIS to refer to NEMO. The same id must be used to refer to NEMO 
+in the \$NBMODEL part of OASIS namcouple in the call of prim\_init\_comp\_proto in cpl\_oasis3f90
+
+\textbf{server\_id} = ''ionemo'' : character, used only in coupled mode. 
+Specify the id used in OASIS to refer to the IO\_SERVER when used in detached mode. 
+Use the same id to refer to the io\_server in the \$NBMODEL part of OASIS namcouple.
+
+\textbf{global\_mpi\_buffer\_size}: integer; define the size in Mb of the MPI buffer used by the io\_server.
+
+\subsubsection{Number of cpu used by the io\_server in detached mode}
+
+The number of cpu used by the io\_server is specified only when launching the model.
+Here is an example of 2 cpus for the io\_server and 6 cpu for opa using mpirun:
+
+\texttt{ -p 2 -e ./ioserver}
+
+\texttt{ -p 6 -e ./opa }
+
+
+\subsection{Practical issues}
+
+\subsubsection{Add your own outputs}
+
+It is very easy to add you own outputs with iom\_put. 4 points must be followed.
+\begin{description}
+\item[1-] in NEMO code, add a \\
+\texttt{      CALL iom\_put( 'identifier', array ) } \\
+where you want to output a 2D or 3D array.
+
+\item[2-] don't forget to add \\
+\texttt{   USE iom            ! I/O manager library }  \\
+in the list of used modules in the upper part of your module. 
+
+\item[3-] in the file\_definition part of the xml file, add the definition of your variable using the same identifier you used in the f90 code.
+\vspace{-20pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+   <field_definition>
+      ...
+      <field id="identifier" description="blabla" />   
+      ...
+   </field_definition> 
+\end{verbatim}
+}}\end{alltt} 
+attributes axis\_ref and grid\_ref must be consistent with the size of the array to pass to iom\_put.
+if your array is computed within the surface module each nn\_fsbc time\_step, 
+add the field definition within the group defined with the id ''SBC'': $<$group id=''SBC''...$>$
+
+\item[4-] add your field in one of the output files   \\
+\vspace{-20pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+   <file id="file_1" .../>   
+      ...
+      <field ref="identifier" />   
+      ...
+   </file>   
+\end{verbatim}
+}}\end{alltt} 
+
+\end{description}
+
+\subsubsection{Several time axes in the output file}
+
+If your output file contains variables with different operations (see operation definition), 
+IOIPSL will create one specific time axis for each operation. Note that inst(X) will have 
+a time axis corresponding to the end each output period whereas all other operators 
+will have a time axis centred in the middle of the output periods.
+
+\subsubsection{Error/bug messages from IOIPSL}
+
+If you get the following error in the standard output file:
+\vspace{-20pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+FATAL ERROR FROM ROUTINE flio_dom_set
+ --> too many domains simultaneously defined 
+ --> please unset useless domains 
+ --> by calling flio_dom_unset 
+\end{verbatim}
+}}\end{alltt} 
+
+You must increase the value of dom\_max\_nb in fliocom.f90 (multiply it by 10 for example). 
+
+If you mix, in the same file, variables with different freq\_op (see definition above), 
+like for example variables from the surface module with other variables, 
+IOIPSL will print in the standard output file warning messages saying there may be a bug. 
+\vspace{-20pt}
+\begin{alltt}  {{\scriptsize
+\begin{verbatim}
+WARNING FROM ROUTINE histvar_seq   
+ --> There were 10 errors in the learned sequence of variables  
+ --> for file   4 
+ --> This looks like a bug, please report it.
+\end{verbatim}
+}}\end{alltt} 
+
+Don't worry, there is no bug, everything is properly working!
+
+     }      %end  \gmcomment
+% ================================================================
+
+
+
+
+
+
+
+
+
+
+
+
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_OBS.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_OBS.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_OBS.tex	(revision 2414)
@@ -45,5 +45,5 @@
 First compile NEMO with \key{diaobs} set.
 
-Next download some ENSEMBLES EN3 data from the website http://www.hadobs.org.
+Next download some ENSEMBLES EN3 data from the \href{http://www.hadobs.org}{website}.
 You should choose observations which are valid for the period of your test run
 because the observation operator compares the model and observations for a
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_SBC.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_SBC.tex	(revision 2414)
@@ -269,6 +269,6 @@
 the turbulent transfer coefficients (momentum, sensible heat and evaporation) 
 from the 10 metre wind speed, air temperature and specific humidity.
-This \citet{Large_Yeager_Rep04} dataset is available through the GFDL web 
-site (http://nomads.gfdl.noaa.gov/nomads/forms/mom4/CORE.html). 
+This \citet{Large_Yeager_Rep04} dataset is available through the 
+\href{http://nomads.gfdl.noaa.gov/nomads/forms/mom4/CORE.html}{GFDL web site}. 
 
 Note that substituting ERA40 to NCEP reanalysis fields 
@@ -361,5 +361,5 @@
 It has been successfully used to interface \NEMO to most of the European atmospheric 
 GCM (ARPEGE, ECHAM, ECMWF, HadAM, LMDz), 
-as well as to WRF (Weather Research and Forecasting Model) (http://wrf-model.org/).
+as well as to \href{http://wrf-model.org/}{WRF} (Weather Research and Forecasting Model).
 
 Note that in addition to the setting of \np{ln\_cpl} to true, the \key{coupled} have to be defined. 
@@ -532,5 +532,5 @@
 grid.
 The original development of this code used the SCRIP package (freely available 
-under a copyright agreement from http://climate.lanl.gov/Software/SCRIP).
+\href{http://climate.lanl.gov/Software/SCRIP}{here} under a copyright agreement).
 In principle, any package can be used to generate the weights, but the
 variables in the input weights file must have the same names and meanings as
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ZDF.tex
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ZDF.tex	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Chapters/Chap_ZDF.tex	(revision 2414)
@@ -326,8 +326,14 @@
 
 
-%\subsubsection{Mixing just below the mixed layer}
-%---------------------------------------------------------------%
+\subsubsection{Mixing just below the mixed layer}
+%--------------------------------------------------------------%
 
 % add here a description of "penetration of TKE" and the associated namelist parameters
+% \np{nn\_etau}, \np{rn\_efr}, \np{nn\_htau}
+
+% from Burchard et al OM 2008 : 
+% the most critical process not reproduced by statistical turbulence models is the activity of internal waves and their interaction with turbulence. After the Reynolds decomposition, internal waves are in principle included in the RANS equations, but later partially excluded by the hydrostatic assumption and the model resolution. Thus far, the representation of internal wave mixing in ocean models has been relatively crude (e.g. Mellor, 1989; Largeetal., 1994; Meier, 2001; Axell, 2002; St. Laurent and Garrett, 2002).
+
+
 
 % -------------------------------------------------------------------------------------------------------------
Index: /branches/nemo_v3_3_beta/DOC/TexFiles/Namelist/namptr
===================================================================
--- /branches/nemo_v3_3_beta/DOC/TexFiles/Namelist/namptr	(revision 2413)
+++ /branches/nemo_v3_3_beta/DOC/TexFiles/Namelist/namptr	(revision 2414)
@@ -2,9 +2,10 @@
 &namptr       !   Poleward Transport Diagnostic
 !-----------------------------------------------------------------------
-   ln_diaptr  = .false.    !  Poleward heat and salt transport (T) or not (F)
-   ln_diaznl  = .false.    !  Add zonal means and meridional stream functions
-   ln_subbas  = .false.    !  Atlantic/Pacific/Indian basins computation (T) or not 
+   ln_diaptr  = .false.     !  Poleward heat and salt transport (T) or not (F)
+   ln_diaznl  = .true.     !  Add zonal means and meridional stream functions
+   ln_subbas  = .true.     !  Atlantic/Pacific/Indian basins computation (T) or not 
                            !  (orca configuration only, need input basins mask file named "subbasins.nc"
-   nf_ptr     =  1         !  Frequency of ptr computation [time step]
-   nf_ptr_wri =  15        !  Frequency of ptr outputs
+   ln_ptrcomp = .true.     !  Add decomposition : overturning
+   nn_fptr    =  1         !  Frequency of ptr computation [time step]
+   nn_fwri    =  15        !  Frequency of ptr outputs [time step]
 /