Index: /trunk/NEMO/TOP_SRC/C14b/trcctl_c14b.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/C14b/trcctl_c14b.F90	(revision 2422)
+++ /trunk/NEMO/TOP_SRC/C14b/trcctl_c14b.F90	(revision 2423)
@@ -33,5 +33,4 @@
       !! ** Purpose :   control the cpp options, namelist and files 
       !!----------------------------------------------------------------------
-
       IF(lwp) THEN
           WRITE(numout,*) ' C14 bomb Model '
@@ -41,17 +40,9 @@
       ! Check number of tracers
       ! -----------------------   
-      IF( jp_c14b > 1) THEN 
-          IF(lwp) THEN 
-              WRITE (numout,*) ' ===>>>> : w a r n i n g '
-              WRITE (numout,*) ' =======   ============= '
-              WRITE (numout,*)                             &
-              &   ' STOP, change jp_c14b to 1 in par_C14b module '  
-          END IF 
-          STOP 'TRC_CTL'
-      END IF 
+      IF( jp_c14b > 1) CALL ctl_stop( ' Change jp_c14b to be equal 1 in par_c14b.F90' )
 
       ! Check tracer names
       ! ------------------
-      IF ( ctrcnm(jpc14) /= 'C14B' ) THEN 
+      IF ( ctrcnm(jpc14) /= 'C14B' ) THEN
            ctrcnm(jpc14)  = 'C14B'
            ctrcnl(jpc14)  = 'Bomb C14 concentration'
@@ -59,11 +50,8 @@
 
       IF(lwp) THEN
-         WRITE (numout,*) ' ===>>>> : w a r n i n g '
-         WRITE (numout,*) ' =======   ============= '
-         WRITE (numout,*) ' we force tracer names'
+         CALL ctl_warn( ' we force tracer names' )
          WRITE(numout,*) ' tracer nb: ',jpc14,' name = ',ctrcnm(jpc14), ctrcnl(jpc14)
          WRITE(numout,*) ' '
-      ENDIF 
-
+      ENDIF
 
       ! Check tracer units
@@ -72,11 +60,9 @@
           ctrcun(jpc14) = 'ration'
           IF(lwp) THEN
-             WRITE (numout,*) ' ===>>>> : w a r n i n g '
-             WRITE (numout,*) ' =======   ============= '
-             WRITE (numout,*) ' we force tracer unit'
+             CALL ctl_warn( ' we force tracer unit' )
              WRITE(numout,*) ' tracer  ',ctrcnm(jpc14), 'UNIT= ',ctrcun(jpc14)
              WRITE(numout,*) ' '
-          ENDIF 
-       ENDIF 
+          ENDIF
+       ENDIF
       !
    END SUBROUTINE trc_ctl_c14b
Index: /trunk/NEMO/TOP_SRC/CFC/trcctl_cfc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/CFC/trcctl_cfc.F90	(revision 2422)
+++ /trunk/NEMO/TOP_SRC/CFC/trcctl_cfc.F90	(revision 2423)
@@ -42,12 +42,5 @@
       ! Check number of tracers
       ! -----------------------   
-      IF( jp_cfc > 2) THEN 
-          IF(lwp) THEN 
-              WRITE (numout,*) ' ===>>>> : w a r n i n g <<<<==='
-              WRITE (numout,*)                             &
-              &   ' STOP, change jp_cfc to 1 or 2 in par_CFC module '  
-          END IF 
-          STOP 'TRC_CTL'
-      END IF 
+      IF( jp_cfc > 2 ) CALL ctl_stop( ' change jp_cfc to 1 or 2 in par_cfc.F90.' )
 
       ! Check tracer names
@@ -62,7 +55,5 @@
 
       IF(lwp) THEN
-         WRITE (numout,*) ' ===>>>> : w a r n i n g '
-         WRITE (numout,*) ' =======   ============= '
-         WRITE (numout,*) ' we force tracer names'
+         CALL ctl_warn( ' We force tracer names ' )
          DO jl = 1, jp_cfc
             jn = jp_cfc0 + jl - 1
@@ -80,6 +71,5 @@
             ctrcun(jn) = 'mole/m3'
             IF(lwp) THEN
-               WRITE (numout,*) ' ===>>>> : w a r n i n g <<<<==='
-               WRITE (numout,*) ' we force tracer unit'
+               CALL ctl_warn( ' We force tracer units ' )
                WRITE(numout,*) ' tracer  ',ctrcnm(jn), 'UNIT= ',ctrcun(jn)
                WRITE(numout,*) ' '
Index: /trunk/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2422)
+++ /trunk/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 2423)
@@ -34,12 +34,12 @@
    INTEGER , PUBLIC    ::   npyear         ! Number of years read in CFC1112 file
    
-   REAL(wp), PUBLIC, DIMENSION(jpyear,jphem, jp_cfc) ::   p_cfc    ! partial hemispheric pressure for CFC          
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)              ::   xphem    ! spatial interpolation factor for patm
+   REAL(wp), PUBLIC, DIMENSION(jpyear,jphem,2     ) ::   p_cfc    ! partial hemispheric pressure for CFC          
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj)             ::   xphem    ! spatial interpolation factor for patm
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj     ,jp_cfc) ::   qtr_cfc  ! flux at surface
    REAL(wp), PUBLIC, DIMENSION(jpi,jpj     ,jp_cfc) ::   qint_cfc ! cumulative flux 
 
-   REAL(wp), DIMENSION(4,jp_cfc) ::   soa   ! coefficient for solubility of CFC [mol/l/atm]
-   REAL(wp), DIMENSION(3,jp_cfc) ::   sob   !    "               "
-   REAL(wp), DIMENSION(4,jp_cfc) ::   sca   ! coefficients for schmidt number in degre Celcius
+   REAL(wp), DIMENSION(4,2) ::   soa   ! coefficient for solubility of CFC [mol/l/atm]
+   REAL(wp), DIMENSION(3,2) ::   sob   !    "               "
+   REAL(wp), DIMENSION(4,2) ::   sca   ! coefficients for schmidt number in degre Celcius
       
    !                          ! coefficients for conversion
Index: /trunk/NEMO/TOP_SRC/LOBSTER/trcctl_lobster.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/LOBSTER/trcctl_lobster.F90	(revision 2422)
+++ /trunk/NEMO/TOP_SRC/LOBSTER/trcctl_lobster.F90	(revision 2423)
@@ -40,14 +40,5 @@
       ! Check number of tracers
       ! -----------------------
-      IF (jp_lobster /= 6) THEN 
-          IF (lwp) THEN 
-              WRITE (numout,*) ' ===>>>> : w a r n i n g '
-              WRITE (numout,*) ' =======   ============= '
-              WRITE (numout,*)                             &
-              &   ' STOP, change jp_lobster to 6 in '           &
-              &   ,'par_lobster.F90 '  
-          END IF 
-          STOP 'TRC_CTL'
-      END IF 
+      IF( jp_lobster /= 6 ) CALL ctl_stop( ' LOBSTER has 6 passive tracers. Change jp_lobster in par_lobster.F90' )
 
       ! Check tracer names
@@ -55,5 +46,5 @@
       IF(   ctrcnm(jpdet) /= 'DET' .OR. ctrcnm(jpzoo) /= 'ZOO' .OR.   &
          &  ctrcnm(jpphy) /= 'PHY' .OR. ctrcnm(jpno3) /= 'NO3' .OR.   &
-         &  ctrcnm(jpnh4) /= 'NH4' .OR. ctrcnm(jpdom) /= 'DOM' .OR.   & 
+         &  ctrcnm(jpnh4) /= 'NH4' .OR. ctrcnm(jpdom) /= 'DOM' .OR.   &
          &  ctrcnl(jpdet) /= 'Detritus'                        .OR.   &
          &  ctrcnl(jpzoo) /= 'Zooplankton concentration'       .OR.   &
@@ -61,5 +52,5 @@
          &  ctrcnl(jpno3) /= 'Nitrate concentration'           .OR.   &
          &  ctrcnl(jpnh4) /= 'Ammonium concentration'          .OR.   &
-         &  ctrcnl(jpdom) /= 'Dissolved organic matter' ) THEN 
+         &  ctrcnl(jpdom) /= 'Dissolved organic matter' ) THEN
          ctrcnm(jpdet)='DET'
          ctrcnl(jpdet)='Detritus'
@@ -73,9 +64,7 @@
          ctrcnl(jpnh4)='Ammonium concentration'
          ctrcnm(jpdom)='DOM'
-         ctrcnl(jpdom)='Dissolved organic matter'          
+         ctrcnl(jpdom)='Dissolved organic matter'
          IF(lwp) THEN
-            WRITE (numout,*) ' ===>>>> : w a r n i n g '
-            WRITE (numout,*) ' =======   ============= '
-            WRITE (numout,*) ' we force tracer names'
+            CALL ctl_warn( ' We force tracer names ' )
             DO jl = 1, jp_lobster
                jn = jp_lob0 + jl - 1
@@ -83,6 +72,6 @@
             END DO
             WRITE(numout,*) ' '
-         ENDIF 
-      ENDIF 
+         ENDIF
+      ENDIF
 
       ! Check tracer units
@@ -92,11 +81,10 @@
             ctrcun(jn) = 'mmole-N/m3'
             IF(lwp) THEN
-               WRITE (numout,*) ' ===>>>> : w a r n i n g '
-               WRITE (numout,*) ' =======   ============= '
-               WRITE (numout,*) ' we force tracer unit'
+               CALL ctl_warn( ' We force tracer units ' )
                WRITE(numout,*) ' tracer  ',ctrcnm(jn), 'UNIT= ',ctrcun(jn)
-            ENDIF 
-         ENDIF 
-      END DO              
+            ENDIF
+         ENDIF
+      END DO
+
    END SUBROUTINE trc_ctl_lobster
 
Index: /trunk/NEMO/TOP_SRC/PISCES/trcctl_pisces.F90
===================================================================
--- /trunk/NEMO/TOP_SRC/PISCES/trcctl_pisces.F90	(revision 2422)
+++ /trunk/NEMO/TOP_SRC/PISCES/trcctl_pisces.F90	(revision 2423)
@@ -41,17 +41,8 @@
    ! -----------------------
 #if  defined key_kriest
-      IF( jp_pisces /= 23) THEN 
+      IF( jp_pisces /= 23) CALL ctl_stop( ' PISCES must have 23 passive tracers. Change jp_pisces in par_pisces.F90' )
 #else
-      IF( jp_pisces /= 24) THEN
+      IF( jp_pisces /= 24) CALL ctl_stop( ' PISCES must have 24 passive tracers. Change jp_pisces in par_pisces.F90' )
 #endif
-          IF (lwp) THEN 
-              WRITE (numout,*) ' ===>>>> : w a r n i n g '
-              WRITE (numout,*) ' =======   ============= '
-              WRITE (numout,*)                               &
-              &   ' STOP, change jp_pisces',               & 
-              &   ' in par_pisces.F90'  
-          END IF 
-          STOP 'TRC_CTL'
-      END IF 
 
    END SUBROUTINE trc_ctl_pisces