Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/domain.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/domain.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/domain.F90	(revision 2431)
@@ -222,7 +222,5 @@
       ENDIF
 
-      n_cla = nn_cla                ! conversion DOCTOR names into model names (this should disappear soon)
-
-      IF( lk_mpp_rep .AND. n_cla /= 0 )   CALL ctl_stop( ' Reproductibility tests (nbit_cmp=1) require n_cla = 0' )
+      IF( lk_mpp_rep .AND. nn_cla /= 0 )   CALL ctl_stop( ' Reproductibility tests (nbit_cmp=1) require n_cla = 0' )
       !
    END SUBROUTINE dom_nam
@@ -268,19 +266,4 @@
       IF( ln_sco ) ioptio = ioptio + 1
       IF ( ioptio /= 1 )   CALL ctl_stop( ' none or several vertical coordinate options used' )
-
-      IF( nprint == 1 .AND. lwp )   THEN
-         WRITE(numout,*) ' MIN val mbathy ', MINVAL( mbathy(:,:) ), ' MAX ', MAXVAL( mbathy(:,:) )
-         WRITE(numout,*) ' MIN val depth t ', MINVAL( fsdept(:,:,:) ),   &
-            &                   ' w ',   MINVAL( fsdepw(:,:,:) ), '3w ', MINVAL( fsde3w(:,:,:) )
-         WRITE(numout,*) ' MIN val e3    t ', MINVAL( fse3t(:,:,:) ), ' f ', MINVAL( fse3f(:,:,:) ),  &
-            &                   ' u ',   MINVAL( fse3u(:,:,:) ), ' u ', MINVAL( fse3v(:,:,:) ),  &
-            &                   ' w ',   MINVAL( fse3w(:,:,:) )
-
-         WRITE(numout,*) ' MAX val depth t ', MAXVAL( fsdept(:,:,:) ),   &
-            &                   ' w ',   MAXVAL( fsdepw(:,:,:) ), '3w ', MAXVAL( fsde3w(:,:,:) )
-         WRITE(numout,*) ' MAX val e3    t ', MAXVAL( fse3t(:,:,:) ), ' f ', MAXVAL( fse3f(:,:,:) ),  &
-            &                   ' u ',   MAXVAL( fse3u(:,:,:) ), ' u ', MAXVAL( fse3v(:,:,:) ),  &
-            &                   ' w ',   MAXVAL( fse3w(:,:,:) )
-      ENDIF
 
    END SUBROUTINE dom_zgr
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/domrea.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/domrea.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/domrea.F90	(revision 2431)
@@ -86,7 +86,7 @@
          inum4                      ! 'mesh_zgr.nc'  file
  
-      REAL(wp), DIMENSION(jpi,jpj) :: &
-         zprt
-      INTEGER :: ik
+      REAL(wp), DIMENSION(jpi,jpj) :: zprt
+      REAL(wp) ::   zrefdep         ! depth of the reference level (~10m)
+      INTEGER  :: ik
       !!----------------------------------------------------------------------
 
@@ -260,4 +260,10 @@
          ENDIF
 
+!!gm BUG in s-coordinate this does not work!
+      ! deepest/shallowest W level Above/Below ~10m
+      zrefdep = 10. - ( 0.1*MINVAL(e3w_0) )                          ! ref. depth with tolerance (10% of minimum layer thickness)
+      nlb10 = MINLOC( gdepw_0, mask = gdepw_0 > zrefdep, dim = 1 )   ! shallowest W level Below ~10m
+      nla10 = nlb10 - 1                                              ! deepest    W level Above ~10m
+!!gm end bug
 
       ! Control printing : Grid informations (if not restart)
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/opa.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/opa.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OFF_SRC/opa.F90	(revision 2431)
@@ -38,4 +38,6 @@
    USE dtadyn          ! Lecture and interpolation of the dynamical fields
    USE stpctl          ! time stepping control            (stp_ctl routine)
+
+   USE c1d             ! 1D configuration
 
    USE iom
@@ -335,4 +337,9 @@
          END SELECT
       ENDIF
+      !
+      IF( lk_c1d .AND. .NOT. lk_iomput )  &
+        CALL ctl_stop( ' The 1D vertical configuration must be used in conjunction',   &
+            &          ' with the IOM Input/Output manager. Compile with key_iomput enabled' )
+      !
 
    END SUBROUTINE opa_flg
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/par_ORCA_R2.h90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/par_ORCA_R2.h90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/OPA_SRC/par_ORCA_R2.h90	(revision 2431)
@@ -82,6 +82,8 @@
       ! jpizoom =   61   ,    &  !: left bottom (i,j) indices of the zoom
       ! jpjzoom =   27   ,    &  !: in data domain indices (160W,60S)
-      jpizoom =   61   ,    &  !: left bottom (i,j) indices of the zoom
-      jpjzoom =    7   ,    &  !: in data domain indices (160W,75S)
+      ! jpizoom =   61   ,    &  !: left bottom (i,j) indices of the zoom
+      ! jpjzoom =    7   ,    &  !: in data domain indices (160W,75S)
+      jpizoom =   110   ,    &  !: left bottom (i,j) indices of the zoom
+      jpjzoom =   97   ,    &  !: in data domain indices (64W,31.5N) BATS site
       ! Domain characteristics
       jperio  =   0            !: lateral cond. type (between 0 and 6)
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2431)
@@ -119,5 +119,5 @@
       IF(lwp)  WRITE(numout,*)
 
-      IF( cp_cfg == "orca" .AND. .NOT. lk_trc_c1d ) THEN      ! ORCA condiguration (not 1D) !
+      IF( cp_cfg == "orca" .AND. .NOT. lk_c1d ) THEN      ! ORCA condiguration (not 1D) !
          !                                                    ! --------------------------- !
          ! set total alkalinity, phosphate, nitrate & silicate
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 2431)
@@ -60,5 +60,5 @@
       INTEGER, INTENT( in ) ::  kstp  ! ocean time-step index
       !! ---------------------------------------------------------------------
-      IF( .NOT. lk_trc_c1d ) THEN
+      IF( .NOT. lk_c1d ) THEN
          !
                                 CALL trc_sbc( kstp )            ! surface boundary condition
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 2431)
@@ -32,7 +32,11 @@
 
    !* IO manager *
-   USE in_out_manager      ! use all the variables
+   USE in_out_manager    
+                          
    !* physical constants *
-   USE phycst              ! use all the variables
+   USE phycst            
+
+   !* 1D configuration
+   USE c1d                                         
 
    !* model domain *
Index: /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2430)
+++ /branches/nemo_v3_3_beta/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2431)
@@ -138,5 +138,5 @@
       tra(:,:,:,:) = 0.
       
-      IF( ln_zps .AND. .NOT. lk_trc_c1d )   &              ! Partial steps: before horizontal gradient of passive
+      IF( ln_zps .AND. .NOT. lk_c1d )   &              ! Partial steps: before horizontal gradient of passive
       &                     CALL zps_hde( nit000, jptra, trn, gtru, gtrv )       ! tracers at the bottom ocean level
 